--
-- @title	Fuel Adjustments v3.0
-- @desc	Allows adjustment of Fuel Prices
-- 
-- @author	TwistedGA
-- @date	10/27/2012
-- @updated	09/24/2016
--
-- You may edit the values of "g_fuelPricePerGallon" and release for Multiplayer. 
-- You may not edit the values found nested within any of the functions for public release without permission from myself.
-- Please contact me with any questions or concerns you may have. Thanks for downloading!
--
g_fuelPricePerGallon = 2.70;
--
fuelAdjust = {};
function fuelAdjust:fillFuel(vehicle, delta)
	if self.trailer ~= nil then
		local trailerFuelFillLevel = self.trailer:getFillLevel(Fillable.FILLTYPE_FUEL);
		if trailerFuelFillLevel > 0 then
			delta = math.min(delta, trailerFuelFillLevel);
			if delta <= 0 then
				return 0;
			end;
		else
			return 0;
		end;
	end;
	if vehicle.setFuelFillLevel ~= nil then
		local oldFillLevel = vehicle.fuelFillLevel
		vehicle:setFuelFillLevel(vehicle.fuelFillLevel + delta);
		delta = vehicle.fuelFillLevel - oldFillLevel;
	else
		if not vehicle:allowFillType(Fillable.FILLTYPE_FUEL, false) then
			return 0;
		end;
		local oldFillLevel = vehicle:getFillLevel(Fillable.FILLTYPE_FUEL);
		vehicle:setFillLevel(oldFillLevel + delta, Fillable.FILLTYPE_FUEL);
		delta = vehicle:getFillLevel(Fillable.FILLTYPE_FUEL) - oldFillLevel;
	end;
	if delta > 0 then
		if self.trailer ~= nil then
			self.trailer:setFillLevel(self.trailer:getFillLevel(Fillable.FILLTYPE_FUEL) - delta, Fillable.FILLTYPE_FUEL);
		else
			local price = delta * 0.2642 * g_fuelPricePerGallon;
			g_currentMission.missionStats:updateStats("expenses", price);
			g_currentMission:addSharedMoney(-price, "vehicleRunningCost");
			g_currentMission:addMoneyChange(-price, self.moneyChangeId);
		end;
	end;
	return delta;
end;
GasStation.fillFuel = fuelAdjust.fillFuel;